--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")

local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}
local InkedColorsHightlight = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 0.5}

local HightlightTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsHoverTex"
local PushedTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsPushedTex"

local ButtonSize = 40
local MySpacing = 1
local BorderSize = 12
local BorderPadding = 0

local MoverPet = CreateFrame("Frame","PetBarDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	--MoverPet:SetSize((ButtonSize * 12)+12, ButtonSize)
	--MoverPet:SetPoint("CENTER", UIParent,"BOTTOM",220.5, 65.5)
	MoverPet:SetFrameStrata("FULLSCREEN_DIALOG")
	MoverPet:SetClampedToScreen(true)
	MoverPet:SetClampRectInsets(0, 0, 0,0)
local MoverPetText  = MoverPet:CreateFontString(nil, "OVERLAY")
	MoverPetText:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.TTF", 15, "OUTLINE")
	MoverPetText:SetPoint("CENTER",MoverPet,"CENTER", 0,0); 
	MoverPetText:SetText("")

local function UpdateMe()
	if(Inked.db.profile.lockframes == false) then
		local point, relativeTo, relativePoint, xOfs, yOfs = MoverPet:GetPoint(n)
			Inked.db.profile.MoverPetX = xOfs
			Inked.db.profile.MoverPetY = yOfs
			Inked.db.profile.MoverPetPoint = point
			MoverPetText:SetText("Pet")				
	end	
end	

local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe) 
local function CreateMoverBackdrop(frame)
	frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
	insets = {top = -2, left = -2, bottom = -2, right = -2}})
	frame:SetBackdropColor(0,0.55,0.95,0.45)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function MakeBarPet()
	if Inked.db.profile.UseActionBars == false then return end
	local BarPetholder = CreateFrame("Frame", "BarPetholder", UIParent, "SecureHandlerStateTemplate")
	BarPetholder:ClearAllPoints()
		

	ButtonSize = Inked.db.profile.PetButtonSize
	local ThisTexture = ("Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButtons")

		for i = 1, NUM_PET_ACTION_SLOTS do
			local InkedBar1 = _G["PetActionButton"..i]
			_G["PetActionButton"..i]:SetWidth(ButtonSize)
			_G["PetActionButton"..i]:SetHeight(ButtonSize)
			_G["PetActionButton"..i]:CreateBeautyBorder(BorderSize)
			_G["PetActionButton"..i]:SetBeautyBorderPadding(BorderPadding)
			_G["PetActionButton"..i]:SetBeautyBorderTexture("white")
			_G["PetActionButton"..i]:SetBeautyBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
			PetActionButton1:CreateBeautyBorder(BorderSize)
			PetActionButton1:SetBeautyBorderPadding(BorderPadding)
			PetActionButton1:SetBeautyBorderTexture("white")
			PetActionButton2:CreateBeautyBorder(BorderSize)
			PetActionButton2:SetBeautyBorderPadding(BorderPadding)
			PetActionButton2:SetBeautyBorderTexture("white")
			PetActionButton3:CreateBeautyBorder(BorderSize)
			PetActionButton3:SetBeautyBorderPadding(BorderPadding)
			PetActionButton3:SetBeautyBorderTexture("white")
			PetActionButton4:CreateBeautyBorder(BorderSize)
			PetActionButton4:SetBeautyBorderPadding(BorderPadding)
			PetActionButton4:SetBeautyBorderTexture("white")
			PetActionButton5:CreateBeautyBorder(BorderSize)
			PetActionButton5:SetBeautyBorderPadding(BorderPadding)
			PetActionButton5:SetBeautyBorderTexture("white")
			PetActionButton6:CreateBeautyBorder(BorderSize)
			PetActionButton6:SetBeautyBorderPadding(BorderPadding)
			PetActionButton6:SetBeautyBorderTexture("white")
			PetActionButton7:CreateBeautyBorder(BorderSize)
			PetActionButton7:SetBeautyBorderPadding(BorderPadding)
			PetActionButton7:SetBeautyBorderTexture("white")
			PetActionButton8:CreateBeautyBorder(BorderSize)
			PetActionButton8:SetBeautyBorderPadding(BorderPadding)
			PetActionButton8:SetBeautyBorderTexture("white")
			PetActionButton9:CreateBeautyBorder(BorderSize)
			PetActionButton9:SetBeautyBorderPadding(BorderPadding)
			PetActionButton9:SetBeautyBorderTexture("white")
			PetActionButton10:CreateBeautyBorder(BorderSize)
			PetActionButton10:SetBeautyBorderPadding(BorderPadding)
			PetActionButton10:SetBeautyBorderTexture("white")
			if Inked.db.profile.ClassABColor == true then
				_G["PetActionButton"..i]:SetBeautyBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
			elseif Inked.db.profile.ClassABColor == false then
				if Inked.db.profile.CustomABColor == true then
					_G["PetActionButton"..i]:SetBeautyBorderColor(Inked.db.profile.ABColorR,Inked.db.profile.ABColorG,Inked.db.profile.ABColorB,Inked.db.profile.ABColorA)
				elseif Inked.db.profile.CustomABColor == false then
					_G["PetActionButton"..i]:SetBeautyBorderColor(1,1,1,1)
				end
			end
			

			InkedBar1:SetAttribute("showgrid", 1)
			InkedBar1.NormalTexture:SetTexture("")
			local Highlight = InkedBar1:GetHighlightTexture()	
			local Pushed = InkedBar1:GetPushedTexture()
			Highlight:SetTexture(HightlightTex)
			Highlight:SetVertexColor(InkedColorsHightlight.r,InkedColorsHightlight.g,InkedColorsHightlight.b,InkedColorsHightlight.a)
			Pushed:SetTexture(PushedTex)	
			
		end
		MoverPet:SetSize((ButtonSize * NUM_PET_ACTION_SLOTS), ButtonSize)

		if(Inked.db.profile.lockframes == false) then
			MoverPet:ClearAllPoints()
			if Inked.db.profile.MoverPetPoint == nil then
				MoverPet:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverPetX,Inked.db.profile.MoverPetY)
			else
				MoverPet:SetPoint(Inked.db.profile.MoverPetPoint, UIParent,Inked.db.profile.MoverPetX,Inked.db.profile.MoverPetY)
			end
			CreateMoverBackdrop(MoverPet)
			MoverPet:SetMovable(true)
			MoverPet:EnableMouse(true)
			MoverPet:RegisterForDrag("LeftButton")
			MoverPet:SetScript("OnDragStart", MoverPet.StartMoving)
			MoverPet:SetScript("OnDragStop", MoverPet.StopMovingOrSizing)
			MoverPet:SetUserPlaced(true)
						
		elseif Inked.db.profile.MoverPetPoint == nil then
				MoverPet:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverPetX,Inked.db.profile.MoverPetY)
			else
				MoverPet:SetPoint(Inked.db.profile.MoverPetPoint, UIParent,Inked.db.profile.MoverPetX,Inked.db.profile.MoverPetY)
		end
		
		PetActionButton1:ClearAllPoints();
		PetActionButton1:SetPoint("LEFT", MoverPet, 0, 0)
		
end		
		local InkedLoginFrame=CreateFrame("Frame")
		InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")
		InkedLoginFrame:RegisterEvent("CINEMATIC_STOP")
		InkedLoginFrame:SetScript("OnEvent", function(self, event) 
			MakeBarPet()									
		end)